package com.njcn.user.utils;

import cn.hutool.core.util.StrUtil;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.EnumUtils;
import com.njcn.user.enums.UserResponseEnum;
import com.njcn.user.enums.UserStatusEnum;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * @author hongawen
 * @version 1.0.0
 * @date 2021年05月26日 17:17
 */
public class UserEnumUtil {

    /**
     * 获取UserResponseEnum实例
     */
    public static UserResponseEnum getUserResponseEnumByMessage(@NotNull Object value) {
        UserResponseEnum userResponseEnum;
        try {
            String message = value.toString();
            if(message.indexOf(StrUtil.C_COMMA)>0){
                value = message.substring(message.indexOf(StrUtil.C_COMMA)+1);
            }
            userResponseEnum = EnumUtils.valueOf(UserResponseEnum.class, value, UserResponseEnum.class.getMethod(BusinessException.GET_MESSAGE_METHOD));
            return Objects.isNull(userResponseEnum) ? UserResponseEnum.LOGIN_WRONG_PWD : userResponseEnum;
        } catch (NoSuchMethodException e) {
            throw new BusinessException(CommonResponseEnum.INTERNAL_ERROR);
        }
    }

    public static Enum<?> getExceptionEnum(HttpResult<Object> result){
        //如果返回错误，且为内部错误，则直接抛出异常
        CommonResponseEnum commonResponseEnum = EnumUtils.getCommonResponseEnumByCode(result.getCode());
        if (commonResponseEnum == CommonResponseEnum.USER_RESPONSE_ENUM) {
            return getUserResponseEnumByMessage(result.getMessage());
        }
        return commonResponseEnum;
    }
}
